package Our_Fireworks
{

/**
 * Author: H. James de St. Germain
 * Date: Spring 2010
 * 
 * A very basic Geometric Vector Class for use with fireworks.
 * 
 */

public class Geom_Vector
{
	/**
	 * direction in the X
	 */
	public var 	x : Number;
	/**
	 * direction in the Y
	 */
	public var	y : Number;

	/**
	 * Initialize a new Geom Vectors x,y
	 */
	public function Geom_Vector( x:Number, y:Number )
	{
		this.x = x;
		this.y = y;
	}

	/**
	 * How to clone a geometric vector
	 * (create a new copy exactly like the current, but distinct in memory)
	 */
	public function clone() : Geom_Vector
	{
		return new Geom_Vector(this.x, this.y);
	}

	/**
	 * Return how long the vector is
	 */
	public function magnitude() : Number
	{
		return Math.sqrt(this.x * this.x + this.y * this.y);
	}

	/**
	 * Return a concise string description of vector
	 */
	public function toString() : String
	{
		return "" + x + ", " + y;
	}

	/**
	 * Change how big the vector is
	 */
	public function scale( factor : Number ) : void
	{
		this.x *= factor;
		this.y *= factor;
	}
}

}