package Our_Fireworks;

/**
 * Author: H. James de St. Germain
 * Date: Spring 2010
 * 
 * A very basic Geometric Vector Class for use with fireworks.
 * 
 */

public class Geom_Vector
{
	/**
	 * direction in the X
	 */
	public float	x;
	/**
	 * direction in the Y
	 */
	public float	y;

	/**
	 * Initialize a new Geom Vectors x,y
	 */
	public Geom_Vector( float x, float y )
	{
		this.x = x;
		this.y = y;
	}

	/**
	 * How to clone a geometric vector
	 * (create a new copy exactly like the current, but distinct in memory)
	 */
	@Override
	public Geom_Vector clone()
	{
		return new Geom_Vector(this.x, this.y);
	}

	/**
	 * Return how long the vector is
	 */
	public float magnitude()
	{
		return (float) Math.sqrt(this.x * this.x + this.y * this.y);
	}

	/**
	 * Return a concise string description of vector
	 */
	@Override
	public String toString()
	{
		return "" + x + ", " + y;
	}

	/**
	 * Change how big the vector is
	 */
	public void scale( float factor )
	{
		this.x *= factor;
		this.y *= factor;
	}
}
